// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.21.12
// source: proto/master/catalog/ticket.proto

package catalog

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// TicketServiceClient is the client API for TicketService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type TicketServiceClient interface {
	CreateTicket(ctx context.Context, in *CreateTicketRequest, opts ...grpc.CallOption) (*Ticket, error)
	UpdateTicket(ctx context.Context, in *UpdateTicketRequest, opts ...grpc.CallOption) (*Ticket, error)
	DeleteTicket(ctx context.Context, in *TicketIdentifierRequest, opts ...grpc.CallOption) (*DeleteTicketRequest, error)
	GetTicketByID(ctx context.Context, in *TicketIdentifierRequest, opts ...grpc.CallOption) (*Ticket, error)
	GetTicketByNo(ctx context.Context, in *TicketIdentifierByNoRequest, opts ...grpc.CallOption) (*Ticket, error)
	GetListTicket(ctx context.Context, in *TicketFilterQuery, opts ...grpc.CallOption) (*ListTicket, error)
	DecreaseTicketQty(ctx context.Context, in *DecreaseTicketQtyRequest, opts ...grpc.CallOption) (*Ticket, error)
	IncreaseTicketQty(ctx context.Context, in *IncreaseTicketQtyRequest, opts ...grpc.CallOption) (*Ticket, error)
}

type ticketServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewTicketServiceClient(cc grpc.ClientConnInterface) TicketServiceClient {
	return &ticketServiceClient{cc}
}

func (c *ticketServiceClient) CreateTicket(ctx context.Context, in *CreateTicketRequest, opts ...grpc.CallOption) (*Ticket, error) {
	out := new(Ticket)
	err := c.cc.Invoke(ctx, "/master.catalog.TicketService/CreateTicket", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ticketServiceClient) UpdateTicket(ctx context.Context, in *UpdateTicketRequest, opts ...grpc.CallOption) (*Ticket, error) {
	out := new(Ticket)
	err := c.cc.Invoke(ctx, "/master.catalog.TicketService/UpdateTicket", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ticketServiceClient) DeleteTicket(ctx context.Context, in *TicketIdentifierRequest, opts ...grpc.CallOption) (*DeleteTicketRequest, error) {
	out := new(DeleteTicketRequest)
	err := c.cc.Invoke(ctx, "/master.catalog.TicketService/DeleteTicket", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ticketServiceClient) GetTicketByID(ctx context.Context, in *TicketIdentifierRequest, opts ...grpc.CallOption) (*Ticket, error) {
	out := new(Ticket)
	err := c.cc.Invoke(ctx, "/master.catalog.TicketService/GetTicketByID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ticketServiceClient) GetTicketByNo(ctx context.Context, in *TicketIdentifierByNoRequest, opts ...grpc.CallOption) (*Ticket, error) {
	out := new(Ticket)
	err := c.cc.Invoke(ctx, "/master.catalog.TicketService/GetTicketByNo", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ticketServiceClient) GetListTicket(ctx context.Context, in *TicketFilterQuery, opts ...grpc.CallOption) (*ListTicket, error) {
	out := new(ListTicket)
	err := c.cc.Invoke(ctx, "/master.catalog.TicketService/GetListTicket", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ticketServiceClient) DecreaseTicketQty(ctx context.Context, in *DecreaseTicketQtyRequest, opts ...grpc.CallOption) (*Ticket, error) {
	out := new(Ticket)
	err := c.cc.Invoke(ctx, "/master.catalog.TicketService/DecreaseTicketQty", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ticketServiceClient) IncreaseTicketQty(ctx context.Context, in *IncreaseTicketQtyRequest, opts ...grpc.CallOption) (*Ticket, error) {
	out := new(Ticket)
	err := c.cc.Invoke(ctx, "/master.catalog.TicketService/IncreaseTicketQty", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// TicketServiceServer is the server API for TicketService service.
// All implementations must embed UnimplementedTicketServiceServer
// for forward compatibility
type TicketServiceServer interface {
	CreateTicket(context.Context, *CreateTicketRequest) (*Ticket, error)
	UpdateTicket(context.Context, *UpdateTicketRequest) (*Ticket, error)
	DeleteTicket(context.Context, *TicketIdentifierRequest) (*DeleteTicketRequest, error)
	GetTicketByID(context.Context, *TicketIdentifierRequest) (*Ticket, error)
	GetTicketByNo(context.Context, *TicketIdentifierByNoRequest) (*Ticket, error)
	GetListTicket(context.Context, *TicketFilterQuery) (*ListTicket, error)
	DecreaseTicketQty(context.Context, *DecreaseTicketQtyRequest) (*Ticket, error)
	IncreaseTicketQty(context.Context, *IncreaseTicketQtyRequest) (*Ticket, error)
	mustEmbedUnimplementedTicketServiceServer()
}

// UnimplementedTicketServiceServer must be embedded to have forward compatible implementations.
type UnimplementedTicketServiceServer struct {
}

func (UnimplementedTicketServiceServer) CreateTicket(context.Context, *CreateTicketRequest) (*Ticket, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateTicket not implemented")
}
func (UnimplementedTicketServiceServer) UpdateTicket(context.Context, *UpdateTicketRequest) (*Ticket, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateTicket not implemented")
}
func (UnimplementedTicketServiceServer) DeleteTicket(context.Context, *TicketIdentifierRequest) (*DeleteTicketRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteTicket not implemented")
}
func (UnimplementedTicketServiceServer) GetTicketByID(context.Context, *TicketIdentifierRequest) (*Ticket, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetTicketByID not implemented")
}
func (UnimplementedTicketServiceServer) GetTicketByNo(context.Context, *TicketIdentifierByNoRequest) (*Ticket, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetTicketByNo not implemented")
}
func (UnimplementedTicketServiceServer) GetListTicket(context.Context, *TicketFilterQuery) (*ListTicket, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetListTicket not implemented")
}
func (UnimplementedTicketServiceServer) DecreaseTicketQty(context.Context, *DecreaseTicketQtyRequest) (*Ticket, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DecreaseTicketQty not implemented")
}
func (UnimplementedTicketServiceServer) IncreaseTicketQty(context.Context, *IncreaseTicketQtyRequest) (*Ticket, error) {
	return nil, status.Errorf(codes.Unimplemented, "method IncreaseTicketQty not implemented")
}
func (UnimplementedTicketServiceServer) mustEmbedUnimplementedTicketServiceServer() {}

// UnsafeTicketServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to TicketServiceServer will
// result in compilation errors.
type UnsafeTicketServiceServer interface {
	mustEmbedUnimplementedTicketServiceServer()
}

func RegisterTicketServiceServer(s grpc.ServiceRegistrar, srv TicketServiceServer) {
	s.RegisterService(&TicketService_ServiceDesc, srv)
}

func _TicketService_CreateTicket_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateTicketRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TicketServiceServer).CreateTicket(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TicketService/CreateTicket",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TicketServiceServer).CreateTicket(ctx, req.(*CreateTicketRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TicketService_UpdateTicket_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateTicketRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TicketServiceServer).UpdateTicket(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TicketService/UpdateTicket",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TicketServiceServer).UpdateTicket(ctx, req.(*UpdateTicketRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TicketService_DeleteTicket_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TicketIdentifierRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TicketServiceServer).DeleteTicket(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TicketService/DeleteTicket",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TicketServiceServer).DeleteTicket(ctx, req.(*TicketIdentifierRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TicketService_GetTicketByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TicketIdentifierRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TicketServiceServer).GetTicketByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TicketService/GetTicketByID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TicketServiceServer).GetTicketByID(ctx, req.(*TicketIdentifierRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TicketService_GetTicketByNo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TicketIdentifierByNoRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TicketServiceServer).GetTicketByNo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TicketService/GetTicketByNo",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TicketServiceServer).GetTicketByNo(ctx, req.(*TicketIdentifierByNoRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TicketService_GetListTicket_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TicketFilterQuery)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TicketServiceServer).GetListTicket(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TicketService/GetListTicket",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TicketServiceServer).GetListTicket(ctx, req.(*TicketFilterQuery))
	}
	return interceptor(ctx, in, info, handler)
}

func _TicketService_DecreaseTicketQty_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DecreaseTicketQtyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TicketServiceServer).DecreaseTicketQty(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TicketService/DecreaseTicketQty",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TicketServiceServer).DecreaseTicketQty(ctx, req.(*DecreaseTicketQtyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TicketService_IncreaseTicketQty_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(IncreaseTicketQtyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TicketServiceServer).IncreaseTicketQty(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TicketService/IncreaseTicketQty",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TicketServiceServer).IncreaseTicketQty(ctx, req.(*IncreaseTicketQtyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// TicketService_ServiceDesc is the grpc.ServiceDesc for TicketService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var TicketService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "master.catalog.TicketService",
	HandlerType: (*TicketServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateTicket",
			Handler:    _TicketService_CreateTicket_Handler,
		},
		{
			MethodName: "UpdateTicket",
			Handler:    _TicketService_UpdateTicket_Handler,
		},
		{
			MethodName: "DeleteTicket",
			Handler:    _TicketService_DeleteTicket_Handler,
		},
		{
			MethodName: "GetTicketByID",
			Handler:    _TicketService_GetTicketByID_Handler,
		},
		{
			MethodName: "GetTicketByNo",
			Handler:    _TicketService_GetTicketByNo_Handler,
		},
		{
			MethodName: "GetListTicket",
			Handler:    _TicketService_GetListTicket_Handler,
		},
		{
			MethodName: "DecreaseTicketQty",
			Handler:    _TicketService_DecreaseTicketQty_Handler,
		},
		{
			MethodName: "IncreaseTicketQty",
			Handler:    _TicketService_IncreaseTicketQty_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "proto/master/catalog/ticket.proto",
}
